diff -ruN vdr-1.7.24/CONTRIBUTORS vdr-1.7.25/CONTRIBUTORS
--- vdr-1.7.24/CONTRIBUTORS	2012-02-19 12:50:20.000000000 +0100
+++ vdr-1.7.25/CONTRIBUTORS	2012-03-02 16:49:57.000000000 +0100
@@ -531,6 +531,7 @@
 
 Rudi Hofer (Rudi.Hofer@gmx.de)
  for his help in keeping 'channels.conf' up to date
+ for reporting a problem with overlapping tab positions in skins when using wide fonts
 
 Gregoire Favre <greg@ulima.unil.ch>
  for fixing some function headers to make them compile with gcc 3.x
@@ -1130,6 +1131,12 @@
  for adding support for handling DVB-T2 transponders
  for suggesting to add member functions Adapter() and Frontend() to cDvbDevice
  for improving handling subtitles of BBC channels
+ for fixing handling subtitle color palettes on channels where subtitles appear
+ "word by word"
+ for reporting a problem with color palettes in subtitles
+ for adding some typecasts to silence gcc compiler warnings
+ for reporting a bug in handling OSD color button texts in case a menu item has
+ texts of its own
 
 Ralf Klueber <ralf.klueber@vodafone.com>
  for reporting a bug in cutting a recording if there is only a single editing mark
@@ -2077,6 +2084,7 @@
  for making the list of tracks given in cStatus::SetAudioTrack() NULL terminated
  for fixing handling kLeft in the calls to cStatus::MsgOsdTextItem()
  for fixing a possible integer overflow in GetAbsTime()
+ for suggesting to add several cTimer::Set...() functions
 
 Philip Prindeville <philipp_subx@redfish-solutions.com>
  for updates to 'sources.conf'
@@ -2372,6 +2380,8 @@
  for fixing stopping subtitle display when switching the primary device
  for fixing plugin arguments corruption with glibc 2.11 on x86_64
  for setting the audio type of language descriptors to 0x00 in the PAT/PMT generator
+ for adding support for automatically selecting subtitles when playing old PES
+ recordings made with the subtitles plugin
 
 Antti Hartikainen <ami+vdr@ah.fi>
  for updating 'S13E' in 'sources.conf'
@@ -2397,6 +2407,8 @@
  recordings of the same broadcast made by different instances of VDR
  for fixing EntriesOnSameFileSystem() to avoid using f_fsid, which may be 0
  for fixing the German translation of "Folder name must not contain '%c'!"
+ for suggestions used in revising priority handling to allow receivers with a priority
+ that is lower than that of live viewing
 
 Jörn Reder <joern@zyn.de>
  for reporting that a recording may unnecessarily block a device with a CAM, while
diff -ruN vdr-1.7.24/HISTORY vdr-1.7.25/HISTORY
--- vdr-1.7.24/HISTORY	2012-02-19 12:49:32.000000000 +0100
+++ vdr-1.7.25/HISTORY	2012-03-03 12:51:32.000000000 +0100
@@ -6888,3 +6888,74 @@
 - Fixed a possible deadlock in time shift mode.
 - Fixed switching into time shift mode when pausing live video (thanks to Reinhard
   Nissl for helping to debug this one).
+
+2012-03-03: Version 1.7.25
+
+- The fps value for channels where it differs from the default is now set correctly
+  when pausing live video.
+- Increased the average character estimate for calculating tab positions in skins,
+  to better suit wide fonts (reported by Rudi Hofer).
+- Fixed getting the subsystem ids of DVB devices in case they have been rearranged
+  via udev rules.
+- Added several cTimer::Set...() functions (suggested by Alexander Rieger).
+- Changed the return value of cTimer::SetFile() to 'void'.
+- Revoked "Fixed a possible deadlock in time shift mode" because it caused trouble with
+  output on vdr-xine and dxr3, and also short glitches when replaying on any output
+  device.
+- Updated the Estonian OSD texts (thanks to Arthur Konovalov).
+- Updated the Finnish OSD texts (thanks to Rolf Ahrenberg).
+- Fixed handling subtitle color palettes on channels where subtitles appear
+  "word by word" (thanks to Rolf Ahrenberg).
+- Fixed upscaling cBitmaps with anti-aliasing (thanks to Rolf Ahrenberg for reporting
+  a problem with color palettes in subtitles).
+- Fixed getting the video aspect ratio for scaling subtitles.
+- Removed the "PrimaryLimit". Old "full featured" DVB cards can be run with the
+  --outputonly option to avoid problems with recording high bandwidth channels.
+  Besides, with HDTV becoming ever more popular those cards are pretty much obsolete
+  by now (the TT S2-6400 has no problems recording and replaying high bandwidth
+  channels simultaneously). And, last but not least, people using software players
+  won't notice this change, anyway.
+- Since cReceivers can have priorities between -99 and 99, the priority
+  for an unused device has been changed from -1 to -100.
+- If the first event in a schedule has a table id of 0x00, any incoming EIT data for
+  that schedule from the DVB stream will be completely ignored. This way an external
+  EPG source can fill the schedules with EPG data that will not be messed up with
+  that from the DVB data stream. Note, though, that this means VDR can not do VPS
+  controlled recordings with such events!
+- Added some typecasts to silence gcc compiler warnings (thanks to Rolf Ahrenberg).
+- Fixed handling overlapping timers in case a VPS timer with higher priority needs
+  to interrupt a timer with lower priority.
+- The code for the RCU remote control unit has been moved into a separate plugin
+  named "rcu".
+  The REMOTE=RCU option in the 'make' call for VDR is now obsolete.
+  The command line option --rcu is now obsolete. Use -Prcu instead. If you have
+  used --rcu with a device path, use -P"rcu -d<device>".
+- Added support for automatically selecting subtitles when playing old PES
+  recordings made with the subtitles plugin (thanks to Anssi Hannula).
+- Revised priority handling to allow receivers with a priority that is lower than
+  that of live viewing (with suggestions from Frank Schmirler):
+  + An idle device (one that is not used for live viewing and has no receiver
+    attached to it) now has priority IDLEPRIORITY (-100).
+  + An unused CAM slot now has priority IDLEPRIORITY.
+  + The default priority of a cReceiver is now MINPRIORITY (-99).
+  + A device that is used only for live viewing (no matter whether it's in Transfer
+    Mode or real live mode) now has priority TRANSFERPRIORITY (-1).
+  + The function cDevice::Receiving() now returns true if there is any receiver
+    attached to the device. Its boolean parameter has no meaning any more.
+  + The default value for the Priority parameter of the function cDevice::ProvidesChannel()
+    has been changed to IDLEPRIORITY.
+- Added a Query parameter to cDevice::GetDevice(), so that devices can be queried
+  without side effects when zapping.
+- Replaced min(max()) calls with the new function constrain().
+- Fixed handling OSD color button texts in case a menu item has texts of its own
+  (reported by Rolf Ahrenberg). If a plugin creates derived cMenuEditItems that set
+  color button texts, these should not set the texts directly by calling
+  cSkinDisplay::Current()->SetButtons(), but rather call the new member function
+  cMenuEditItem::SetHelp().
+- Moved the call to cStatus::MsgChannelSwitch(this, 0) to the beginning of
+  cDevice::SetChannel(), so that any receivers that have been attached to the
+  device by plugins may be detached before the final call to GetDevice().
+  This actually reverts "Only calling cStatus::MsgChannelSwitch() if a channel
+  is actually going to be switched or has actually been switched successfully"
+  which was made in version 1.1.10, so please report if this has any unwanted
+  side effects.
diff -ruN vdr-1.7.24/INSTALL vdr-1.7.25/INSTALL
--- vdr-1.7.24/INSTALL	2012-02-16 11:23:32.000000000 +0100
+++ vdr-1.7.25/INSTALL	2012-02-27 12:03:14.000000000 +0100
@@ -47,15 +47,12 @@
 to one of the following values in the 'make' call to make the respective control
 the default:
 
-  REMOTE=RCU    control via the "Remote Control Unit" receiver
-                (see http://www.tvdr.de/remote.htm)
   REMOTE=LIRC   control via the "Linux Infrared Remote Control"
                 (see http://www.lirc.org)
 
-Alternatively you can use the '--rcu' or '--lirc' options at runtime.
-These options accept an optional path to the remote control device,
-the defaults of which can be set via the RCU_DEVICE and LIRC_DEVICE macros,
-respectively.
+Alternatively you can use the '--lirc' option at runtime.
+This option accepts an optional path to the remote control device,
+the default of which can be set via the LIRC_DEVICE macro.
 
 If your video directory will be on a VFAT partition, you can call VDR with
 the command line option '--vfat'.
diff -ruN vdr-1.7.24/MANUAL vdr-1.7.25/MANUAL
--- vdr-1.7.24/MANUAL	2012-01-14 14:03:21.000000000 +0100
+++ vdr-1.7.25/MANUAL	2012-02-25 14:38:52.000000000 +0100
@@ -763,15 +763,6 @@
                          These margins are added automatically to timers that
                          are created from the EPG data.
 
-  Primary limit = 0      The minimum priority a timer must have to be allowed to
-                         use the primary DVB interface, or to force another timer
-                         with higher priority to use the primary DVB interface.
-                         This is mainly useful for recordings that should take
-                         place only when there is nothing else to do, but should
-                         never keep the user from viewing stuff on the primary
-                         interface. On systems with only one DVB card, timers
-                         with a priority below PrimaryLimit will never execute.
-
   Default priority = 50  The default Priority and Lifetime values used when
   Default lifetime = 99  creating a new timer event. A Lifetime value of 99
                          means that this recording will never be deleted
diff -ruN vdr-1.7.24/Make.config.template vdr-1.7.25/Make.config.template
--- vdr-1.7.24/Make.config.template	2012-01-18 13:20:51.000000000 +0100
+++ vdr-1.7.25/Make.config.template	2012-02-27 11:56:28.000000000 +0100
@@ -6,7 +6,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: Make.config.template 2.5 2012/01/18 12:20:51 kls Exp $
+# $Id: Make.config.template 2.6 2012/02/27 10:56:28 kls Exp $
 
 ### The C compiler and options:
 
@@ -37,7 +37,6 @@
 ### The remote control:
 
 LIRC_DEVICE ?= /var/run/lirc/lircd
-RCU_DEVICE  ?= /dev/ttyS1
 
 ## Define if you want vdr to not run as root
 #VDR_USER ?= vdr
diff -ruN vdr-1.7.24/Makefile vdr-1.7.25/Makefile
--- vdr-1.7.24/Makefile	2012-01-18 13:19:37.000000000 +0100
+++ vdr-1.7.25/Makefile	2012-02-27 11:54:38.000000000 +0100
@@ -4,7 +4,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: Makefile 2.24 2012/01/18 12:19:37 kls Exp $
+# $Id: Makefile 2.25 2012/02/27 10:54:38 kls Exp $
 
 .DELETE_ON_ERROR:
 
@@ -42,7 +42,7 @@
 
 OBJS = audio.o channels.o ci.o config.o cutter.o device.o diseqc.o dvbdevice.o dvbci.o\
        dvbplayer.o dvbspu.o dvbsubtitle.o eit.o eitscan.o epg.o filter.o font.o i18n.o interface.o keys.o\
-       lirc.o menu.o menuitems.o nit.o osdbase.o osd.o pat.o player.o plugin.o rcu.o\
+       lirc.o menu.o menuitems.o nit.o osdbase.o osd.o pat.o player.o plugin.o\
        receiver.o recorder.o recording.o remote.o remux.o ringbuffer.o sdt.o sections.o shutdown.o\
        skinclassic.o skins.o skinsttng.o sourceparams.o sources.o spu.o status.o svdrp.o themes.o thread.o\
        timers.o tools.o transfer.o vdr.o videodir.o
@@ -63,9 +63,8 @@
 endif
 
 LIRC_DEVICE ?= /var/run/lirc/lircd
-RCU_DEVICE  ?= /dev/ttyS1
 
-DEFINES += -DLIRC_DEVICE=\"$(LIRC_DEVICE)\" -DRCU_DEVICE=\"$(RCU_DEVICE)\"
+DEFINES += -DLIRC_DEVICE=\"$(LIRC_DEVICE)\"
 
 DEFINES += -D_GNU_SOURCE
 
diff -ruN vdr-1.7.24/PLUGINS/src/dvbhddevice/dvbhdffdevice.c vdr-1.7.25/PLUGINS/src/dvbhddevice/dvbhdffdevice.c
--- vdr-1.7.24/PLUGINS/src/dvbhddevice/dvbhdffdevice.c	2012-02-15 14:14:49.000000000 +0100
+++ vdr-1.7.25/PLUGINS/src/dvbhddevice/dvbhdffdevice.c	2012-02-28 10:18:56.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: dvbhdffdevice.c 1.39 2012/02/15 13:14:49 kls Exp $
+ * $Id: dvbhdffdevice.c 1.40 2012/02/28 09:18:56 kls Exp $
  */
 
 #include <stdint.h>
@@ -48,6 +48,25 @@
      devHdffOffset = adapter;
      isHdffPrimary = true;
      mHdffCmdIf = new HDFF::cHdffCmdIf(fd_osd);
+
+     /* reset some stuff in case the VDR was killed before and had no chance
+	to clean up. */
+     mHdffCmdIf->CmdOsdReset();
+
+     mHdffCmdIf->CmdAvSetVideoSpeed(0, 100);
+     mHdffCmdIf->CmdAvSetAudioSpeed(0, 100);
+
+     mHdffCmdIf->CmdAvEnableVideoAfterStop(0, false);
+     mHdffCmdIf->CmdAvSetPcrPid(0, 0);
+     mHdffCmdIf->CmdAvSetVideoPid(0, 0, HDFF_VIDEO_STREAM_MPEG1);
+     mHdffCmdIf->CmdAvSetAudioPid(0, 0, HDFF_AUDIO_STREAM_MPEG1);
+
+     ioctl(fd_video, VIDEO_SELECT_SOURCE, VIDEO_SOURCE_DEMUX);
+     mHdffCmdIf->CmdAvSetDecoderInput(0, 0);
+     mHdffCmdIf->CmdAvEnableSync(0, true);
+     mHdffCmdIf->CmdAvSetPlayMode(0, true);
+     /* reset done */
+
      mHdffCmdIf->CmdAvSetAudioDelay(gHdffSetup.AudioDelay);
      mHdffCmdIf->CmdAvSetAudioDownmix((HdffAudioDownmixMode_t) gHdffSetup.AudioDownmix);
      mHdffCmdIf->CmdMuxSetVideoOut((HdffVideoOut_t) gHdffSetup.AnalogueVideo);
diff -ruN vdr-1.7.24/PLUGINS/src/dvbhddevice/hdffcmd.c vdr-1.7.25/PLUGINS/src/dvbhddevice/hdffcmd.c
--- vdr-1.7.24/PLUGINS/src/dvbhddevice/hdffcmd.c	2012-02-06 12:08:48.000000000 +0100
+++ vdr-1.7.25/PLUGINS/src/dvbhddevice/hdffcmd.c	2012-02-28 10:19:09.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: hdffcmd.c 1.23 2012/02/06 11:08:48 kls Exp $
+ * $Id: hdffcmd.c 1.24 2012/02/28 09:19:09 kls Exp $
  */
 
 #include <stdint.h>
@@ -188,6 +188,7 @@
 
     if (HdffCmdOsdCreateDisplay(mOsdDev, Width, Height, ColorType, &newDisplay) == 0)
         return newDisplay;
+    LOG_ERROR_STR("Error creating display");
     return HDFF_INVALID_HANDLE;
 }
 
@@ -217,7 +218,7 @@
 
 void cHdffCmdIf::CmdOsdRenderDisplay(uint32_t hDisplay)
 {
-    //printf("Render\n");
+    //printf("Render %08X\n", hDisplay);
     HdffCmdOsdRenderDisplay(mOsdDev, hDisplay);
 }
 
@@ -231,6 +232,7 @@
                                   pColors, &newPalette);
     if (err == 0)
         return newPalette;
+    LOG_ERROR_STR("Error creating palette");
     return HDFF_INVALID_HANDLE;
 }
 
@@ -260,6 +262,7 @@
     err = HdffCmdOsdCreateFontFace(mOsdDev, pFontData, DataSize, &newFontFace);
     if (err == 0)
         return newFontFace;
+    LOG_ERROR_STR("Error creating font face");
     return HDFF_INVALID_HANDLE;
 }
 
@@ -278,6 +281,7 @@
     err = HdffCmdOsdCreateFont(mOsdDev, hFontFace, Size, &newFont);
     if (err == 0)
         return newFont;
+    LOG_ERROR_STR("Error creating font");
     return HDFF_INVALID_HANDLE;
 }
 
@@ -316,7 +320,7 @@
                                   int BmpWidth, int BmpHeight, int BmpSize,
                                   HdffColorType_t ColorType, uint32_t hPalette)
 {
-    //printf("Bitmap (%d,%d) %d x %d\n", X, Y, BmpWidth, BmpHeight);
+    //printf("Bitmap %08X (%d,%d) %d x %d, %08X\n", hDisplay, X, Y, BmpWidth, BmpHeight, hPalette);
     HdffCmdOsdDrawBitmap(mOsdDev, hDisplay, X, Y, pBitmap, BmpWidth, BmpHeight,
                          BmpSize, ColorType, hPalette);
 }
diff -ruN vdr-1.7.24/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_osd.c vdr-1.7.25/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_osd.c
--- vdr-1.7.24/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_osd.c	2011-10-16 17:12:49.000000000 +0200
+++ vdr-1.7.25/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_osd.c	2012-02-26 22:47:20.000000000 +0100
@@ -103,10 +103,15 @@
     {
         if (osd_cmd.result_len > 0)
         {
-            *NewDisplay = (resultData[6] << 24)
-                        | (resultData[7] << 16)
-                        | (resultData[8] << 8)
-                        | resultData[9];
+            if (resultData[2] == HDFF_MSG_TYPE_ANSWER)
+            {
+                *NewDisplay = (resultData[6] << 24)
+                            | (resultData[7] << 16)
+                            | (resultData[8] << 8)
+                            | resultData[9];
+            }
+            else
+                err = -1;
         }
     }
     return err;
@@ -295,10 +300,15 @@
     {
         if (osd_cmd.result_len > 0)
         {
-            *NewPalette = (resultData[6] << 24)
-                        | (resultData[7] << 16)
-                        | (resultData[8] << 8)
-                        | resultData[9];
+            if (resultData[2] == HDFF_MSG_TYPE_ANSWER)
+            {
+                *NewPalette = (resultData[6] << 24)
+                            | (resultData[7] << 16)
+                            | (resultData[8] << 8)
+                            | resultData[9];
+            }
+            else
+                err = -1;
         }
     }
     return err;
@@ -400,10 +410,15 @@
     {
         if (osd_cmd.result_len > 0)
         {
-            *NewFontFace = (resultData[6] << 24)
-                         | (resultData[7] << 16)
-                         | (resultData[8] << 8)
-                         | resultData[9];
+            if (resultData[2] == HDFF_MSG_TYPE_ANSWER)
+            {
+                *NewFontFace = (resultData[6] << 24)
+                             | (resultData[7] << 16)
+                             | (resultData[8] << 8)
+                             | resultData[9];
+            }
+            else
+                err = -1;
         }
     }
     return err;
@@ -451,10 +466,15 @@
     {
         if (osd_cmd.result_len > 0)
         {
-            *NewFont = (resultData[6] << 24)
-                     | (resultData[7] << 16)
-                     | (resultData[8] << 8)
-                     | resultData[9];
+            if (resultData[2] == HDFF_MSG_TYPE_ANSWER)
+            {
+                *NewFont = (resultData[6] << 24)
+                         | (resultData[7] << 16)
+                         | (resultData[8] << 8)
+                         | resultData[9];
+            }
+            else
+                err = -1;
         }
     }
     return err;
diff -ruN vdr-1.7.24/PLUGINS/src/pictures/HISTORY vdr-1.7.25/PLUGINS/src/pictures/HISTORY
--- vdr-1.7.24/PLUGINS/src/pictures/HISTORY	2012-02-17 15:01:48.000000000 +0100
+++ vdr-1.7.25/PLUGINS/src/pictures/HISTORY	2012-02-27 12:41:02.000000000 +0100
@@ -67,3 +67,7 @@
 2012-02-17:
 
 - cReadDir::Next() now skips directory entries "." and "..".
+
+2012-02-27: Version 0.1.2
+
+- Removed an obsolete command line option.
diff -ruN vdr-1.7.24/PLUGINS/src/pictures/pictures.c vdr-1.7.25/PLUGINS/src/pictures/pictures.c
--- vdr-1.7.24/PLUGINS/src/pictures/pictures.c	2012-02-17 15:00:48.000000000 +0100
+++ vdr-1.7.25/PLUGINS/src/pictures/pictures.c	2012-02-27 12:40:15.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: pictures.c 2.4 2012/02/17 14:00:48 kls Exp $
+ * $Id: pictures.c 2.5 2012/02/27 11:40:15 kls Exp $
  */
 
 #include <getopt.h>
@@ -11,7 +11,7 @@
 #include "menu.h"
 #include "player.h"
 
-static const char *VERSION       = "0.1.1";
+static const char *VERSION       = "0.1.2";
 static const char *DESCRIPTION   = trNOOP("A simple picture viewer");
 static const char *MAINMENUENTRY = trNOOP("Pictures");
 
@@ -86,7 +86,7 @@
      };
 
   int c;
-  while ((c = getopt_long(argc, argv, "d:s:", long_options, NULL)) != -1) {
+  while ((c = getopt_long(argc, argv, "d:", long_options, NULL)) != -1) {
         switch (c) {
           case 'd': strn0cpy(PictureDirectory, optarg, sizeof(PictureDirectory));
                     break;
